JUCE: PropertySet Class Reference

JUCE

Public Member Functions | Protected Member Functions | List of all members
PropertySet Class Reference
juce_core » containers

A set of named property values, which can be strings, integers, floating point, etc. More...

`#include <juce_PropertySet.h>`

Inheritance diagram for PropertySet:

## Public Member Functions
| PropertySet (bool ignoreCaseOfKeyNames=false)
| Creates an empty PropertySet. More...
| PropertySet (const PropertySet &other)
| Creates a copy of another PropertySet. More...
PropertySet & | operator= (const PropertySet &other)
| Copies another PropertySet over this one. More...
virtual | ~PropertySet ()
| Destructor. More...
String | getValue (StringRef keyName, const String &defaultReturnValue=String()) const noexcept
| Returns one of the properties as a string. More...
int | getIntValue (StringRef keyName, int defaultReturnValue=0) const noexcept
| Returns one of the properties as an integer. More...
double | getDoubleValue (StringRef keyName, double defaultReturnValue=0.0) const noexcept
| Returns one of the properties as an double. More...
bool | getBoolValue (StringRef keyName, bool defaultReturnValue=false) const noexcept
| Returns one of the properties as an boolean. More...
std::unique_ptr< XmlElement > | getXmlValue (StringRef keyName) const
| Returns one of the properties as an XML element. More...
void | setValue (StringRef keyName, const var &value)
| Sets a named property. More...
void | setValue (StringRef keyName, const XmlElement *xml)
| Sets a named property to an XML element. More...
void | addAllPropertiesFrom (const PropertySet &source)
| This copies all the values from a source PropertySet to this one. More...
void | removeValue (StringRef keyName)
| Deletes a property. More...
bool | containsKey (StringRef keyName) const noexcept
| Returns true if the properties include the given key. More...
void | clear ()
| Removes all values. More...
StringPairArray & | getAllProperties () noexcept
| Returns the keys/value pair array containing all the properties. More...
const CriticalSection & | getLock () const noexcept
| Returns the lock used when reading or writing to this set. More...
std::unique_ptr< XmlElement > | createXml (const String &nodeName) const
| Returns an XML element which encapsulates all the items in this property set. More...
void | restoreFromXml (const XmlElement &xml)
| Reloads a set of properties that were previously stored as XML. More...
void | setFallbackPropertySet (PropertySet *fallbackProperties) noexcept
| Sets up a second PopertySet that will be used to look up any values that aren't set in this one. More...
PropertySet * | getFallbackPropertySet () const noexcept
| Returns the fallback property set. More...

## Protected Member Functions
virtual void | propertyChanged ()
| Subclasses can override this to be told when one of the properties has been changed. More...

## Detailed Description

A set of named property values, which can be strings, integers, floating point, etc.

Effectively, this just wraps a StringPairArray in an interface that makes it easier to load and save types other than strings.

See the PropertiesFile class for a subclass of this, which automatically broadcasts change messages and saves/loads the list from a file.

## Constructor & Destructor Documentation

## ◆ PropertySet() [1/2]

PropertySet::PropertySet | ( | bool | ignoreCaseOfKeyNames = `false` | ) |

Creates an empty PropertySet.

Parameters

  ignoreCaseOfKeyNames | if true, the names of properties are compared in a case-insensitive way

## ◆ PropertySet() [2/2]

PropertySet::PropertySet | ( | const PropertySet & | other | ) |

Creates a copy of another PropertySet.

## ◆ ~PropertySet()

virtual PropertySet::~PropertySet | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ operator=()

PropertySet & PropertySet::operator= | ( | const PropertySet & | other | ) |

Copies another PropertySet over this one.

## ◆ getValue()

String PropertySet::getValue | ( | StringRef | keyName,
|  | const String & | defaultReturnValue = `String()`
| ) |  | const
| noexcept

Returns one of the properties as a string.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

Referenced by StandalonePluginHolder::getLastFile(), and StandalonePluginHolder::reloadPluginState().

## ◆ getIntValue()

int PropertySet::getIntValue | ( | StringRef | keyName,
|  | int | defaultReturnValue = `0`
| ) |  | const
| noexcept

Returns one of the properties as an integer.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

## ◆ getDoubleValue()

double PropertySet::getDoubleValue | ( | StringRef | keyName,
|  | double | defaultReturnValue = `0.0`
| ) |  | const
| noexcept

Returns one of the properties as an double.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

## ◆ getBoolValue()

bool PropertySet::getBoolValue | ( | StringRef | keyName,
|  | bool | defaultReturnValue = `false`
| ) |  | const
| noexcept

Returns one of the properties as an boolean.

The result will be true if the string found for this key name can be parsed as a non-zero integer.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

Referenced by StandalonePluginHolder::reloadAudioDeviceState().

## ◆ getXmlValue()

std::unique_ptr< XmlElement > PropertySet::getXmlValue | ( | StringRef | keyName | ) | const

Returns one of the properties as an XML element.

The result will a new XMLElement object. It may return nullptr if the key isn't found, or if the entry contains an string that isn't valid XML.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve

Referenced by StandalonePluginHolder::reloadAudioDeviceState().

## ◆ setValue() [1/2]

void PropertySet::setValue | ( | StringRef | keyName,
|  | const var & | value
| ) |  |

Sets a named property.

Parameters

  keyName | the name of the property to set. (This mustn't be an empty string)
  value | the new value to set it to

Referenced by StandalonePluginHolder::savePluginState(), and StandalonePluginHolder::setLastFile().

## ◆ setValue() [2/2]

void PropertySet::setValue | ( | StringRef | keyName,
|  | const XmlElement * | xml
| ) |  |

Sets a named property to an XML element.

Parameters

  keyName | the name of the property to set. (This mustn't be an empty string)
  xml | the new element to set it to. If this is a nullptr, the value will be set to an empty string

See also
  getXmlValue

## ◆ addAllPropertiesFrom()

void PropertySet::addAllPropertiesFrom | ( | const PropertySet & | source | ) |

This copies all the values from a source PropertySet to this one.

This won't remove any existing settings, it just adds any that it finds in the source set.

## ◆ removeValue()

void PropertySet::removeValue | ( | StringRef | keyName | ) |

Deletes a property.

Parameters

  keyName | the name of the property to delete. (This mustn't be an empty string)

## ◆ containsKey()

bool PropertySet::containsKey | ( | StringRef | keyName | ) | const
| noexcept

Returns true if the properties include the given key.

## ◆ clear()

void PropertySet::clear | ( |  | ) |

Removes all values.

## ◆ getAllProperties()

StringPairArray & PropertySet::getAllProperties | ( |  | ) |
| noexcept

Returns the keys/value pair array containing all the properties.

## ◆ getLock()

const CriticalSection & PropertySet::getLock | ( |  | ) | const
| noexcept

Returns the lock used when reading or writing to this set.

## ◆ createXml()

std::unique_ptr< XmlElement > PropertySet::createXml | ( | const String & | nodeName | ) | const

Returns an XML element which encapsulates all the items in this property set.

The string parameter is the tag name that should be used for the node.

See also
  restoreFromXml

## ◆ restoreFromXml()

void PropertySet::restoreFromXml | ( | const XmlElement & | xml | ) |

Reloads a set of properties that were previously stored as XML.

The node passed in must have been created by the createXml() method.

See also
  createXml

## ◆ setFallbackPropertySet()

void PropertySet::setFallbackPropertySet | ( | PropertySet * | fallbackProperties | ) |
| noexcept

Sets up a second PopertySet that will be used to look up any values that aren't set in this one.

If you set this up to be a pointer to a second property set, then whenever one of the getValue() methods fails to find an entry in this set, it will look up that value in the fallback set, and if it finds it, it will return that.

Make sure that you don't delete the fallback set while it's still being used by another set! To remove the fallback set, just call this method with a null pointer.

See also
  getFallbackPropertySet

## ◆ getFallbackPropertySet()

PropertySet * PropertySet::getFallbackPropertySet | ( |  | ) | const
| noexcept

Returns the fallback property set.

See also
  setFallbackPropertySet

## ◆ propertyChanged()

virtual void PropertySet::propertyChanged | ( |  | ) |
| protectedvirtual

Subclasses can override this to be told when one of the properties has been changed.

Reimplemented in PropertiesFile.

The documentation for this class was generated from the following file:

- juce_PropertySet.h